////////////////////////////////////////////////////////////////////////////////
// MAIN.C - Joltima  (Justin's Ultima) orginal z80 version by Justin Karneges //
// C version by Athlor (athlor@gmail.com) Blackberry 957, Cybiko & TI89 ports //
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include <led.h>
#include "joltima.h"
#include "map.h"
#include "gfx.h"
#define TIMER_EVENT 0x40001

char VersionPtr[] = "Joltima";
int AppStackSize = 3000;
MESSAGE MSG;

char map[64][84];  // rows columns
char X,Y,h,v,C=0;  // starting pos, tmp pos & frame toggle
int r=0, s=0, t=0, u=0,p,w; // Mostly temp DOCUMENT!
char x[3],y[3];    // Extra char pos
char q[64],q2[64]; // String storage
char anim=1;       // Animation flag
char c;            // contrast

const unsigned char bf[]={128,64,32,16,8,4,2,1};
const char bn[]={1,2,4,8};

AlertConfiguration MySnd = {
  50,               // Duty
  35,               // Volume (initial)
  35,               // Volume (max)
  1,                // Repetitions
  10,               // VibrateTime (1/10 sec)
  PULSE_VIBRATE,    // VibrateType
  VIBRATE_AND_TONE, // InHolsterNotify
  VIBRATE_AND_TONE, // OutOfHolsterNotify
  0
};               // Pause

/////////////////////////////////////////////////////////////////
int AnimCallback(MESSAGE *Msg) {
  if (anim) {
    LcdRasterOp(COPY_SRC,16,16,&Chars,96+C,0,NULL,64,64);  // Draw char (was COPY_SRC)
    LcdRasterOp(COPY_SRC,16,16,&Chars,64+C,0,NULL,64+x[0]*16,64+y[0]*16);
    LcdRasterOp(COPY_SRC,16,16,&Chars,32+C,0,NULL,64+x[0]*16+x[1]*16,64+y[0]*16+y[1]*16);
    LcdRasterOp(COPY_SRC,16,16,&Chars,C=16-C,0,NULL,64+x[0]*16+x[1]*16+x[2]*16,64+y[0]*16+y[1]*16+y[2]*16);
  }
  return FALSE; // Msg not forwarded
}

void fadeout(void) {
  for (h=c; h>0; h--) {
    LcdSetContrast(h);
    RimSleep(10);
  }
}

void fadein(void) {
  for (h=0; h<c+1; h++) {
    LcdSetContrast(h);
    RimSleep(10);
  }
}

void blinkled(void) {
  RimSetLed(LED_MESSAGE,LED_ON);
  RimSleep(100);
  RimSetLed(LED_MESSAGE,LED_OFF);
}

void tbox(char *s) {
  LcdRasterOp(WHITE,160,33,NULL,0,0,NULL,0,126); // Clear bottom
  LcdDrawBox(DRAW_BLACK,0,126,159,159);          // Draw msg frame
  LcdPutStringXY(-1,127,s,-1,LCD_CENTERED|LCD_MULTILINE);
}

void wait4click(void) { // Poss combine both for wait4(THUMB_CLICK)
  while (RimGetMessage(&MSG),MSG.Event!=THUMB_CLICK);  // Wait for click
}

void wait4unclick(void) {
  while (RimGetMessage(&MSG),MSG.Event!=THUMB_UNCLICK); // Wait for unclick
}

void mbox(char *s) {
  anim=0; // Animation OFF
  tbox(s);
  wait4click();
  anim=1; // Animation ON
}

char menu(int x,int y, char *s)  // Display menu: Returns 0-? or -1 for ESC
{                                // NEW mnu,len,a,b,c USES
  char mnu[10][16],len=0; // Menu string array & len
  char a=0,b=0,c=0;       // Temp x,y & char count
  do {
    mnu[b][a]=s[c];       // Add char to menu str
    if (mnu[b][a]=='\n'||mnu[b][a]==0) { // End of cur str
      mnu[b][a]=0;        // Replace CR w/ 0 & inc line #
      if (LcdGetStringWidth(mnu[b],-1,-1)>len) len=LcdGetStringWidth(mnu[b],-1,-1);
      b++;a=0;            // Reset chr counter
    } else a++;            // Inc chr counter in cur str
  } while (s[c++]!=0);                              // End of whole str
  LcdRasterOp(WHITE,len+5,3+b*8,NULL,0,0,NULL,x,y); // Draw box
  LcdDrawBox(DRAW_BLACK,x,y,x+len+5,y+3+b*8);       // Draw frame
  for (a=0; a<b; a++)
    LcdPutStringXY(x+3,y+2+a*8,mnu[a],-1,0);        // Selections
  c=0;
  for (;;) {
    LcdRasterOp(INVERT_DEST,len+4,8,NULL,0,0,NULL,x+1,y+2+8*c); // Hilight
    RimGetMessage(&MSG); // Wait for key press
    LcdRasterOp(INVERT_DEST,len+4,8,NULL,0,0,NULL,x+1,y+2+8*c); // Unhilight
    if (MSG.SubMsg==KEY_ESCAPE) break; // ESCAPE
    switch (MSG.Event) {
    case THUMB_ROLL_UP:   if (c>0) c--; break;
    case THUMB_ROLL_DOWN: if (c<b-1) c++; break;
    case THUMB_CLICK: return c; break; // Selected
    }
  }
  return -1;
}

void mapline(char max){ // New , Uses r,s,t
  map[r][s++]=p&15;
  if (s>max) {
    r++; s=0;
  }
  t++;
}

void uncom(const unsigned char *mn,char ln,int ml) { // Umcompress RLE
  r=0, s=0, t=0, u=0;         // (tile=lower 4bits / copy=upper 4bits)
  do {                        // r=xpos,s=ypos,t=total,u=compos,
    p=mn[u++];
    if (p>15) {
      for (w=0; w<(p>>4); w++)
        mapline(ln);
    } else mapline(ln);
  } while (t<ml);
}

void loadmap(void)    // Loads a map (contained in maptype & mapnum)
{                     // NEW , USES v,x,y, r,s,t,u
  for (v=0; v<3; v++) {
    x[v]=0;y[v]=0;
  }  // Reset following players
  switch (maptype) {
  case OVER: { // 84w x 64h (RLE encoded, tile=lower 4bits/copy=upper)
    uncom(over,83,5375);
    X=MapData[mapnum][4];Y=MapData[mapnum][5];
    mapnum=0;
    break;
  }
  case TOWN: { // 38w x 34h (RLE encoded, tile=lower 4bits/copy=upper)
    uncom(town[mapnum],37,1292);
    X=MapData[mapnum][2];Y=MapData[mapnum][3];
    for (v=0; v<TownData[mapnum][0]; v++)
      map[TownData[mapnum][v*5+2]][TownData[mapnum][v*5+1]]=16+TownData[mapnum][v*5+3]; // Placeholder for NPC
    break;
  }
  case CAVE: { // 24w x 24h (9 caves, 1 bit/block) 73 bytes each (3x24)
    r=0, s=0, t=0, u=0;
    for (v=0;v<34;v++)
      for (h=0;h<38;h++)
        map[v][h]=15;      // Clear area with grass (stamp 15)
    for (v=0;v<24;v++)
      for (h=0;h<3;h++)
        for (r=0; r<8; r++) // Scan thru byte, if bit then lay block
          map[5+v][7+h*8+r]=caves[((mapnum-5)*72)+v*3+h]&bf[r]?1:11;
    X=MapData[mapnum][2];Y=MapData[mapnum][3];
    break;
  }
  }
  for (v=0; v<28; v++)
    if (SearchData[v][0]==maptype&&SearchData[v][1]==mapnum&&pickup[v]==0)
      map[SearchData[v][3]][SearchData[v][2]]=12; // Draw chest if not picked up
}

char getplayer(void) {      // Displays menu of player, returns player 0-3 
  char i; q[0]=0;           // NEW i, USES q[],
  for (i=0; i<4; i++) {
    strcat(q,names[i]);
    if (i<3)  strcat(q,"\n");
  }
  return menu(57,0,q);
}

void item(void) {                    // Displays menu of carried items
  char i, d, _temp;                  // NEW i d, USES q[],
  if (itemnum>0) {
    q[0]=0; // Reset string len
    for (i=0; i<itemnum; i++) {
      strcat(q,str[items[i]]);
      if (i!=itemnum-1) strcat(q,"\n");
    }
    i=menu(19,0,q); // Store item # in i (0-?)
    if (i>-1) {
      d=menu(37,0,items[i]>2?"Equip\nDrop":"Use \nDrop");
      if (d>-1) {
        if (d==1)                    // DROP
          items[i]=items[--itemnum]; // Delete item from inventory
        else {                       // USE-EQUIP
          d=getplayer();             // Player to use/equip
          if (ItemData[items[i]][1]==0) {             // HEALING
            hp[d]=hp[d]+ItemData[items[i]][2];        // Heal by amount
            if (hp[d]>hpmax[d]) hp[d]=hpmax[d]; // Check over-healing
            items[i]=items[--itemnum];          // Delete item from inv
          } else {
            if (bn[d]&ItemData[items[i]][0]) { // Check class
              if (ItemData[items[i]][1]==1) {  // WEAPON
                _temp=eqwep[d];
                eqwep[d]=items[i];
                items[i]=_temp;
              } else {                         // ARMOR
                _temp=eqarm[d];
                eqarm[d]=items[i];
                items[i]=_temp;
              }
            } else mbox("Unable to equip!");
          }
        } // Not drop
      }   // End if(d>-1)
    }     // End if(i>-1)
  } else mbox("You have no items!");
}

void wiggle(int posx, char posy,const BitMap *c,char o) { // Wiggles char
  int i;  // New i
  for (i=0; i<9; i++) {
    LcdRasterOp(COPY_SRC,16,16,c,o*16,0,NULL,posx-2+(rand()%5),posy-2+(rand()%5)); // Randomly place bmp (-2 > +2)
    RimSleep(10);
    LcdRasterOp(WHITE,20,20,c,0,0,NULL,posx-2,posy-2); // Clear bmp
  }
}

char combat(void) {      // Combat mode: Returns -1 if party dead
  RimTestAlert(TONE_SEQUENCE_5,&MySnd);     // NEW , USES v,w,r,s,
  fadeout(); // Fade to white
  anim=0;    // Turn animating OFF
  char enemyX[5]={8,8,8,40,40};    char enemyY[5]={48,72,96,56,88};
  int playrX[4]={104,104,136,136}; char playrY[4]={56,88,56,88};
  char slots[5]; char enemyHP[5];
  v=shards*3+(rand()&3);
  char /*numP=4,*/ numE=BattleForm[v][0]; // Number of players & enemies
  for (w=0; w<numE; w++) {
    slots[w]=BattleForm[v][3+w];
    enemyHP[w]=EnemyData[slots[w]][0];
  }
  r=3;s=0; // First player's turn (Thief)
  LcdSetContrast(c);
  do { /////////////////////////////////////////////////////MAIN COMBAT LOOP///
    LcdClearDisplay();
    LcdCopyBitmapToDisplay(&Battle,0,0);
    tbox(" ");
    for (w=0; w<4; w++) {
      LcdPutStringXY(10+w*38,129,names[w],-1,0); // Print player names
      RimSprintf(q,64,"%d/%d",hp[w],hpmax[w]);
      LcdPutStringXY(10+w*38,137,q,-1,0);        // Print player stats
      LcdPutStringXY(10+w*38,145,class[w],-1,0); // Print class
      LcdRasterOp(COPY_SRC,16,16,&Chars,96-w*32,0,NULL,playrX[w],playrY[w]); // Draw player
    }
    for (w=0; w<numE; w++)
      LcdRasterOp(COPY_SRC,16,16,&Enemy,slots[w]*16,0,NULL,enemyX[w],enemyY[w]); // Draw enemies
    LcdDrawBox(DRAW_BLACK,playrX[r]-2,playrY[r]-2,playrX[r]+17,playrY[r]+17);    // Draw box around player
    switch (menu(0,0,"Attack\nItem\nRun")) {
    case 0: { // Attack
      LcdCopyBitmapToDisplay(&Battle,0,0); // Redraw battle bgd (coverup menu)
      do {
        LcdDrawBox(DRAW_BLACK,enemyX[s]-2,enemyY[s]-2,enemyX[s]+17,enemyY[s]+17); // Hilight
        RimGetMessage(&MSG); // Wait for key
        LcdDrawBox(DRAW_WHITE,enemyX[s]-2,enemyY[s]-2,enemyX[s]+17,enemyY[s]+17); // Unhilight
        if (MSG.SubMsg==KEY_ESCAPE) return -1; // ESCAPE <<<< WATCH
        switch (MSG.Event) {
        case THUMB_ROLL_UP:   if (s>0) s--; break;
        case THUMB_ROLL_DOWN: if (s<numE-1) s++; break;
        case THUMB_CLICK:
          wiggle(enemyX[s],enemyY[s],&Enemy,slots[s]);
          enemyHP[s]--;
          if (enemyHP[s]<0) {
            if (s!=numE-1) {
              slots[s]=slots[numE-1];
            }
            numE--;
          }
          break; // Selected
        }
      } while (MSG.Event!=THUMB_CLICK);
    }
    break;
    case 1:   // Item
      item();
      break;
    case 2:   // Run (temp for DEBUGGING MODE)
      anim=1; // Turn animating ON
      return 0;
      break;
    }
    s=0; r--; if (r<0) r=3;
  } while (numE); ///////////////////////////////////////////END MAIN COMBAT///
  mbox("Enemies DEFEATED!");
  anim=1; // Turn animating ON
  return 0;
}

//  RimSprintf(q,64,"v: %d  BattleForm[v][0]: %d  ",v,BattleForm[v][0]);
//  LcdPutStringXY(0,118,q,-1,0); // Debug

///////////////////////////////////////////////////////////////////////////////
void JoltimaMain(void) {
  char a,b,i,m; // Temp abi, m=moving
  HandleType H; FileType F; // File I/O
  PID pid; pid.Name=VersionPtr;
  pid.EnableForeground=TRUE;
  pid.Icon=NULL; RimSetPID(&pid);
  c=LcdGetContrast(); // Save screen contrast
  srand(RimGetTicks());     // Seed rand

start:
  LcdClearDisplay();
  LcdCopyBitmapToDisplay(&bitmapTitle16,38,30); // Show Title bmp
  if (menu(60,85,"New\nContinue")) { // CONTINUE
    H=DbGetHandle("Joltima.chr");
    if (DbSize(H,TRUE)==0) {
      mbox("File Error!"); goto start;
    } // No data
    F = DbFileOpen(H, 256);
    DbFileRead(F,&maptype,1); DbFileRead(F,&mapnum,1); DbFileRead(F,&boat,1);
    DbFileRead(F,names,24);   DbFileRead(F,level,4);   DbFileRead(F,hp,4);
    DbFileRead(F,hpmax,4);    DbFileRead(F,p_str,4);   DbFileRead(F,p_def,4);
    DbFileRead(F,p_agl,4);    DbFileRead(F,p_ext,4);   DbFileRead(F,exp,4);
    DbFileRead(F,eqwep,4);    DbFileRead(F,eqarm,4);   DbFileRead(F,&itemnum,1);
    DbFileRead(F,items,8);    DbFileRead(F,&shards,1); DbFileRead(F,&gold,1);
    DbFileRead(F,pickup,30);  DbFileClose(F,FALSE);
  } else { // NEW CHAR
    fadeout();
    LcdClearDisplay();
    LcdPutStringXY(-1,32,"Welcome, men!\nYou have been appointed\nby me,\
                   Lisa of Daphnar,\n to free our land from\nturmoil. The evil wizard\nKorifca\
                   has taken\nover the monsters\nto fight as his army.\nHe can be stopped\
                   only\none way...  The Shards!",-1,LCD_CENTERED|LCD_MULTILINE);
    fadein();
    wait4click();
    wait4unclick();
    fadeout(); LcdSetContrast(c);
    for (v=0; v<4; v++) {
      LcdClearDisplay();
      LcdRasterOp(COPY_SRC,16,16,&Chars,(3-v)*32,0,NULL,16,16); // Draw char
      LcdPutStringXY(16,44,class[v],-1,0);                      // Class type
      for (h=0;h<5;h++) {
        do {
          if (h) LcdPutStringXY(16,34,names[v],h,0); // First part of name
          else  LcdPutStringXY(16,34,"",-1,0);      // none, so set tab
          LcdPutStringXY(-1,-1,&names[v][h],1,TEXT_INVERT); // Letter being set
          LcdClearToEndOfLine();                    // Clean if last was longer
          RimGetMessage(&MSG); // Wait for key press
          if (MSG.Event==THUMB_ROLL_UP&&names[v][h]>31)    names[v][h]--; // Dec letter
          if (MSG.Event==THUMB_ROLL_DOWN&&names[v][h]<123) names[v][h]++; // Inc letter
        } while (MSG.Event!=THUMB_CLICK);
        wait4unclick();
      }
    }
    // Other NEW Data
  } // End NEW CHAR
  loadmap();
  RimSetTimer(TIMER_EVENT, 50, TIMER_PERIODIC); // Set period (100th/sec)
  RimRegisterMessageCallback(TIMER_EVENT, 0xffffffff, AnimCallback);

  for (;;) { /////////////////////////////////////////////START MESSAGE LOOP///
    m=0;  // Reset moving
    for (v=0;v<10;v++)
      for (h=0;h<10;h++)
        if (map[Y-4+v][X-4+h]>15) // NPC marker check (>16)
          LcdRasterOp(COPY_SRC,16,16,&Chars,(map[Y-4+v][X-4+h]&15)*32,0,NULL,h*16,v*16);
        else LcdRasterOp(COPY_SRC,16,16,&Stamps,map[Y-4+v][X-4+h]*16,maptype*32,NULL,h*16,v*16); // Draw frame

    LcdRasterOp(COPY_SRC,16,16,&Chars,96,0,NULL,64,64);  // Draw char (was COPY_SRC)
    LcdRasterOp(COPY_SRC,16,16,&Chars,64,0,NULL,64+x[0]*16,64+y[0]*16);
    LcdRasterOp(COPY_SRC,16,16,&Chars,32,0,NULL,64+x[0]*16+x[1]*16,64+y[0]*16+y[1]*16);
    LcdRasterOp(COPY_SRC,16,16,&Chars,0,0,NULL,64+x[0]*16+x[1]*16+x[2]*16,64+y[0]*16+y[1]*16+y[2]*16);
//  RimSprintf(q,64,"X:%d Y:%d  x[0]:%d y[0]:%d  ",X,Y,x[0],y[0]);
//  LcdPutStringXY(0,152,q,-1,0); // Debug

    RimGetMessage(&MSG);
    switch (MSG.Device) {
    case DEVICE_KEYPAD:
      switch (MSG.Event) {
      case THUMB_CLICK:
        RimSprintf(q,64,"Gold - %d   Shards - %d",gold,shards);
        tbox(q);
        anim=0; // Animation OFF
        switch (menu(0,0,"Search\nItem\nStatus\nSave")) {
        case 0:  // Search
          a=1; // Reset find
          for (i=0; i<28; i++) {
            if (SearchData[i][2]==X&&SearchData[i][3]==Y&&SearchData[i][0]==maptype&&SearchData[i][1]==mapnum&&pickup[i]==0) {
              if (SearchData[i][4]==255) {
                strcpy(q,"You find a shard!");
                shards++;
              } else if (itemnum>7) {
                mbox("Carrying too much!");break;
              } else {
                RimSprintf(q,64,"You find %s.",str[SearchData[i][4]]);
                items[itemnum++]=SearchData[i][4]; // Add item & inc
              }
              mbox(q);     // Display 'You find' msg
              a=0;         // Set item to found
              pickup[i]=1; // Mark item as picked up
              map[Y][X]=1; // Erase chest on map
            }
          }
          if (a) mbox("You find nothing.");
          break;
        case 1:  // Item
          item();
          break;
        case 2:  // Status
          for (i=0; i<4; i++) {
            a=(i&1)*52; b=85+(i&2)*19;                   // Each char
            LcdRasterOp(WHITE,52,36,NULL,0,0,NULL,a,b);  // Clear box
            LcdDrawBox(DRAW_BLACK,a,b,a+50,b+36);        // Draw msg frame
            RimSprintf(q,64,"%s L:%d",names[i],level[i]);
            LcdPutStringXY(a+3,b+2,q,-1,0);              // Print name lev
            RimSprintf(q,64,"HP %d/%d",hp[i],hpmax[i]);
            LcdPutStringXY(a+3,b+11,q,-1,0);             // HP/HP remaining
            LcdPutStringXY(a+3,b+19,str[eqwep[i]],-1,0); // Equiped weapon
            LcdPutStringXY(a+3,b+27,str[eqarm[i]],-1,0); // Equiped armor
          }
          wait4click();
          break;
        case 3:  // Save
          H=DbGetHandle("Joltima.chr");
          F=DbFileOpen(H,256);
          DbFileWrite(F,&maptype,1); DbFileWrite(F,&mapnum,1); DbFileWrite(F,&boat,1);
          DbFileWrite(F,names,24);   DbFileWrite(F,level,4);   DbFileWrite(F,hp,4);
          DbFileWrite(F,hpmax,4);    DbFileWrite(F,p_str,4);   DbFileWrite(F,p_def,4);
          DbFileWrite(F,p_agl,4);    DbFileWrite(F,p_ext,4);   DbFileWrite(F,exp,4);
          DbFileWrite(F,eqwep,4);    DbFileWrite(F,eqarm,4);   DbFileWrite(F,&itemnum,1);
          DbFileWrite(F,items,8);    DbFileWrite(F,&shards,1); DbFileWrite(F,&gold,1);
          DbFileWrite(F, pickup, 30);
          DbFileClose(F,TRUE);
          mbox("Game saved.");
          break;
        }
        anim=1; // Animation ON
        break;
    case KEY_DOWN: case KEY_REPEAT: {
        switch (MSG.SubMsg) {
        case KEY_ESCAPE: // ESC key exits
          a=menu(108,130,"Continue\nQuit");
          if (a==1) {
cleanup:    RimKillTimer(TIMER_EVENT);
            RimRegisterMessageCallback(TIMER_EVENT,0xffffffff,NULL);
            RibbonShowRibbon();
            RimTerminateThread();
            break;
          }
          break;
        case 'q': v=Y-1;h=X;m=1;break; // NORTH
        case 'z': v=Y+1;h=X;m=1;break; // SOUTH
        case 'a': h=X-1;v=Y;m=1;break; // WEST
        case 's': h=X+1;v=Y;m=1;break; // EAST
        }
        if (m) { // Moving
          if (map[v][h]<7||map[v][h]==12) {
            x[2]=x[1];x[1]=x[0];x[0]=X-h;y[2]=y[1];y[1]=y[0];y[0]=Y-v;X=h;Y=v;
          } // Walkable space (NORM 7-TEST 13)
          if (map[v][h]==15) {
            maptype=OVER;loadmap();
          }       // Exit town or cave
          if ((map[Y][X]==3||map[Y][X]==4)&&maptype==OVER) { // Enter town or cave
            for (v=0; v<15; v++)
              if (MapData[v][0]==X&&MapData[v][1]==Y) {
                maptype=(map[Y][X]==4?CAVE:TOWN);mapnum=v;loadmap();
              }
          }
          if (map[v][h]>15||(map[v][h]==10&&map[v+(v-Y)][h+(h-X)]>15)) { // Bump into NPC
            if (map[v][h]==10&&map[v+(v-Y)][h+(h-X)]>15) {
              v=v+(v-Y);h=h+(h-X);
            } // << YUK, FIX THIS CRAP
            for (i=0; i<TownData[mapnum][0]; i++) {
              if (TownData[mapnum][i*5+2]==v&&TownData[mapnum][i*5+1]==h) {
                if (TownData[mapnum][i*5+4]==0)        // Talker
                  mbox(msgs[TownData[mapnum][i*5+5]]); // What they say
                else if (TownData[mapnum][i*5+4]==1) { // Shop
                  RimSprintf(q,64,"Welcome to\nthe Weapon shop.\nHow may I help you?\nYou have %dg.",gold);
                  tbox(q);
                  q[0]=0; // reset string len
                  for (i=0; i<4; i++) {
                    RimSprintf(q2,64,"%s-%d",str[ShopData[mapnum][i*2]],ShopData[mapnum][i*2+1]);
                    strcat(q,q2);
                    if (i<3) strcat(q,"\n");
                  }
                  v=menu(0,0,q);
                  if (v>-1) {
                    if (itemnum>7) mbox("Carrying too much!");
                    else if (gold>=ShopData[mapnum][v*2+1]) {
                      gold-=ShopData[mapnum][v*2+1];
                      items[itemnum++]=ShopData[mapnum][v*2];
                      mbox("Thank You.");
                    } else mbox("You don't have\nenough gold!");
                  }
                } else { // Inn
                  RimSprintf(q,64,"Welcome to\nthe Inn. A room?\nonly 10g!\nYou have %dg.",gold);
                  tbox(q);
                  if (menu(0,0,"No\nYes")) { // ADD ESC !!!!!!
                    if (gold>9) {
                      gold -= 10;
                      for (i=0; i<4; i++) hp[i]=hpmax[i];
                      anim=0; // Animation OFF
                      tbox("Thank You.");
                      RimSleep(99);
                      LcdRasterOp(BLACK,160,160,NULL,0,0,NULL,0,0); // Clear box
                      mbox("Is it morning already?");
                    } else mbox("You don't have\nenough gold!");
                  }
                }
              }
            }
          }
          if (maptype!=TOWN&&(rand()&15)==0) // Random combat
            if (combat()<0) {
              LcdRasterOp(BLACK,160,160,NULL,0,0,NULL,0,0); // Clear box
              mbox("Sadly, the world\nwas never saved...");
              goto cleanup;
            }
        } // end if(m) (Moving)
      }   // end key_down
      }   // end MSG.event switch
    }     // end MSG.device switch
  }       // end message for(;;) loop
}

void PagerMain(void) {
  RibbonRegisterFunction(VersionPtr,&Icon,0,40,JoltimaMain,AppStackSize);
}
